package com.zd.exam.mapper;

import com.zd.exam.domain.ElExamDept;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 考试部门(ElExamDept)表数据库访问层
 *
 * @author liubo
 * @since 2021-08-31 09:25:37
 */
public interface ElExamDeptMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ElExamDept queryById(Long id);

    /**
     * 查询指定行数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<ElExamDept> queryAllByLimit(@Param("offset") int offset, @Param("limit") int limit);


    /**
     * 通过实体作为筛选条件查询
     *
     * @param elExamDept 实例对象
     * @return 对象列表
     */
    List<ElExamDept> queryAll(ElExamDept elExamDept);

    /**
     * 新增数据
     *
     * @param elExamDept 实例对象
     * @return 影响行数
     */
    int insert(ElExamDept elExamDept);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<ElExamDept> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<ElExamDept> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<ElExamDept> 实例对象列表
     * @return 影响行数
     */
    int insertOrUpdateBatch(@Param("entities") List<ElExamDept> entities);

    /**
     * 修改数据
     *
     * @param elExamDept 实例对象
     * @return 影响行数
     */
    int update(ElExamDept elExamDept);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Long id);

    int deleteByExamId(Long examId);

    int checkOnlyOneExamByScopeType(@Param("scopeType") Integer scopeType,
                                    @Param("examId") Long examId,
                                    @Param("deptIds") List<Long> deptIds);
}

